package com.mocn.airBottle;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;

import com.mocn.framework.BackGroundLayer;
import com.mocn.framework.BaseView;
import com.mocn.framework.Utils;

public class GameView extends BaseView implements OnTouchListener {
	BackGroundLayer backLayer;// 
	Plane plane;// ɻ
	public boolean pressPlane = false;

	public GameView(Context context) {
		super(context);
		setOnTouchListener(this);
		// Ʊ
		backLayer = new BackGroundLayer(Utils.getBitmap("game/bg.png"), 800,
				480);
		backLayer.setPosition(0, 0);

		// Ʒɻ
		plane = new Plane(Utils.getBitmap("game/plane.png"), 150, 179);
		plane.setPosition(40, 300);

	}

	@Override
	public void drawSurfaceView(Canvas canvas, Paint paint) {
		super.drawSurfaceView(canvas, paint);
		GameData.bulletsAndEnemy();// жӵ͵оײ
		GameData.createEnemy();// о
	}

	/**
	 * ¼ִеķ
	 */
	@Override
	public boolean onTouch(View v, MotionEvent event) {
		if (event.getAction() == MotionEvent.ACTION_DOWN) {// ִе¼
			// µзɻִеķ
			if (Utils.inRect(plane.x - plane.w / 2, plane.y - plane.h / 2,
					plane.w, plane.h, event.getX(), event.getY())) {
				pressPlane = true;// ɻƶΪtrue
			}
		} else if (event.getAction() == MotionEvent.ACTION_MOVE) {// ϶ִе¼
			if (pressPlane) {
				plane.setPosition(event.getX(), event.getY());// ɻΪ϶ʱ
			}
		} else if (event.getAction() == MotionEvent.ACTION_UP) {// ͷŰʱִеķ
			pressPlane = false;// ɻƶΪfalse
		}
		return true;
	}

}
