package com.mocn.framework;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.view.SurfaceHolder;
import android.view.SurfaceHolder.Callback;
import android.view.SurfaceView;

/**
 * ϷĻ SurfaceHolder̵߳Ŀ͹رգӽMdrawSurfaceView
 * 
 * @author Administrator
 * 
 */
public abstract class BaseView extends SurfaceView implements Callback,
		Runnable {
	private SurfaceHolder holder;// SurfaceHolder
	private Thread currentThread;// Thread
	public int sleepTime = 20;// ˯ʱ

	public BaseView(Context context) {
		super(context);
		holder = this.getHolder();// õholder
		holder.addCallback(this);// õ
	}

	/**
	 * ̵߳ķ
	 */
	public void startThread() {
		currentThread = new Thread(this);// õ̵߳Ķ
		currentThread.start();// ߳
	}

	/**
	 * ر̵߳ķ
	 */
	public void stopThread() {
		currentThread = null;// ߳Ϊ
	}

	/**
	 * ıʱִеķ
	 */
	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {

	}

	/**
	 * 洴ʱִеķ
	 */
	@Override
	public void surfaceCreated(SurfaceHolder holder) {
		startThread();// Ϸ߳
	}

	/**
	 * Ϸݻʱִеķ
	 */
	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		stopThread();// رϷ߳
	}

	/**
	 * ƽķ
	 * 
	 * @param canvas
	 * @param paint
	 */
	public void drawSurfaceView(Canvas canvas, Paint paint) {
		LayerManager.drawLayerManager(canvas, paint);// 
	}

	/**
	 * ̵߳ĿƷ
	 */
	@Override
	public void run() {
		Canvas canvas;
		Paint paint = new Paint();
		while (currentThread != null) {
			canvas = holder.lockCanvas();
			drawSurfaceView(canvas, paint);
			holder.unlockCanvasAndPost(canvas);
			 try {
			 Thread.sleep(sleepTime);
			 } catch (InterruptedException e) {
			 e.printStackTrace();
			 }
		}
	}

}
